
#include "xbp.ch"
#include "Appevent.ch"
#include "common.ch"
#include "inkey.ch"

#IFDEF UseDXE
   #include "DLL.ch"
   DLLFUNCTION GetModuleHandleA( cModule ) USING STDCALL FROM  KERNEL32.DLL
#ENDIF

#define CRLF CHR(13)+CHR(10)

PROCEDURE appsys ; return
// ---------------------------------------------------------------------------

PROCEDURE Main()
LOCAL nEvent, oXbp, mp1, mp2
LOCAL oDlg

   SET DATE GERMAN
   SET CENTURY ON
   SET ALTER TO LOGFILE2.TXT

   //
   oDlg := TbDialog():New(AppDesktop(),,{0,0}, {900,395},,.T.)

   oDlg:taskList := .T.
   oDlg:title    := "native Toolbar"
   oDlg:icon     := 1
   oDlg:close    := {|p1,p2,oo| PostAppEvent(xbeP_Quit,,,oo) }
   oDlg:drawingArea:resize := {| aOldSize, aNewSize, oSelf | MyResize(aOldSize,aNewSize,oSelf,oDlg)  }
   oDlg:Create()

   oDlg:drawingArea:ClipChildren := .T.
   CenterControl(oDlg)

*  oDlg:CreateToolbar(50,"DEMO2STD.EXE")
   oDlg:CreateToolbar(34,"DEMO2STD.EXE")

   oDlg:Show()
   SetAppFocus( oDlg )

   PostAppEvent(xbeP_Resize,{1,1},oDlg:drawingArea:CurrentSize(),oDlg:drawingArea )

   nEvent := xbe_None
   WHILE nEvent != xbeP_Close
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent ( nEvent, mp1, mp2 )
      IF nEvent == xbeP_Quit
         QUIT   // AppQuit()
      ENDIF
   ENDDO

   oDlg:destroy()
   SET ALTER TO

RETURN

PROCEDURE MyResize(aOldSize,aNewSize,oSelf,oDlg)
LOCAL nHeight := 32
LOCAL aChild := {}
LOCAL i,iMax
LOCAL oBtn
LOCAL aPos        := oDlg:CurrentPos()
LOCAL aMainPos    := {0,0}

   IF aOldSize[1] == 0 .AND. aOldSize[2] == 0               // was minimize
      aOldSize := aNewSize                                  // New Size

   ELSEIF aNewSize[1] == 0 .OR. aNewSize[2] == 0            // is now minimized
      RETURN

   ELSEIF aNewSize[1] == aOldSize[1] .AND. aNewSize[2] == aOldSize[2]
      RETURN
   ENDIF                                                    // same Size

   oSelf:lockUpdate(.T.)

   IF oDlg:oToolbar:isDerivedFrom("DXE_ToolBar")
      nHeight := oDlg:oToolbar:CurrentSize()[2]
   ENDIF

   oDlg:oToolbar:setPos({0,aNewSize[2]-nHeight})
   oDlg:oToolbar:setSize({aNewSize[1],nHeight})

   oSelf:lockUpdate(.F.)
   oSelf:invalidateRect()

RETURN


CLASS TbForm FROM XbpDialog
   EXPORTED:

      VAR oToolbar
      VAR oFontName
      VAR oFontSize

      METHOD init
      METHOD create
ENDCLASS

METHOD TbForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   DEFAULT oParent  TO AppDesktop(), ;
           aPos     TO {2,-3}, ;
           lVisible TO .F.

   DEFAULT aPP TO {}
   AAdd ( aPP, { XBP_PP_COMPOUNDNAME, "8.Arial" } )

   IF Empty(aSize) == .T.
      IF IsMemberVar(self,"ClientSize") == .T.
         aSize := {0,0}
      ELSE
         aSize := {340,276}
      ENDIF
   ENDIF

   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   IF aSize[1] == 0 .AND. aSize[2] == 0
      ::XbpDialog:ClientSize := {332,250}
   ENDIF

RETURN self

METHOD TbForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

CLASS TbDialog FROM TbForm
   EXPORTED:
      METHOD init
      METHOD create

      METHOD CreateToolbar()

ENDCLASS

METHOD TbDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::TbForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

METHOD TbDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::TbForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

METHOD TbDialog:CreateToolbar(nHeight,cDLL)
LOCAL aSize   := ::DrawingArea:CurrentSize()
LOCAL hModule
LOCAL oButton
LOCAL aPos    := {0,0}
LOCAL oBtn
LOCAL aBtnSize := {0,0}

DEFAULT nHeight TO 32

   IF VALTYPE(nHeight) = "N"
      aPos [2] := aSize[2] -nHeight
      aSize[2] := nHeight
   ELSE
      Msgbox("Error Parameter"+VAR2CHAR(nHeight))
      RETURN self
   ENDIF

   IF ValType(cDLL) == "C"
      hModule := GetModuleHandleA( cDLL )
   ELSE
      hModule := GetModuleHandleA( 0 )
   ENDIF

   ::oToolbar := DXE_Toolbar():New(::DrawingArea,,aPos,aSize,,.F.)

   ::oToolbar:borderStyle  := XBPFRAME_NONE      // all other give WS_BORDER
   ::oToolbar:textAlign    := XBPALIGN_BOTTOM    // or XBPALIGN_RIGHT
   ::oToolbar:appearance   := XBP_APPEARANCE_3D  // or XBP_APPEARANCE_FLAT
   ::oToolbar:wrappable    := .F.
   ::oToolbar:showToolTips := .T.
   ::oToolbar:lNORESIZE    := .T.                // is CCS_NORESIZE

   ::oToolbar:create()


   //
   // not in Xbase++ right click on Buttonr ( o:RbDown )
   // must be before o:buttonClick
   //
   IF ::oToolbar:isDerivedFrom( "DXE_Toolbar")
      ::oToolbar:buttonRClick    := {|oMenu| HandleItemRClick(oMenu)}
   ENDIF

   ::oToolbar:buttonClick := {|oButton| IF(VALTYPE(oButton:activate)="B",EVAL(oButton:activate), MsgBox("Knopf [" + ;
                          LTRIM(STR(oButton:index ))+" "+ ;
                           Var2Char(oButton:caption)+ ;
                          "] angeklickt!"))}

   ::oToolbar:ButtonMenuClick := {|oMenu| HandleItemClick(oMenu)}

   //
   // load System Icon.
   // must be first
   //
*  ::oToolbar:loadImageSet( XBPTOOLBAR_STDIMAGES_SMALL )
   ::oToolbar:loadImageSet( XBPTOOLBAR_STDIMAGES_LARGE )

   //
   // Syntax
   //
   // Additem(cCaption, xImage, xDisabledImage, xHotImage, cDLL, nStyle, cKey, cImageType, nWidth ,bAction)
   //
   // new Parameter not in Xbase++
   //
   // cImageType : "ICO" or "BMP" as Resource
   // nWidth     : fixed Wide if need e.g. Placeholder or DropDownMenu
   // bAction    : Activate Codeblock Slot

   oBtn := ::oToolbar:addItem("new"     ,STD_IMAGE_FILENEW   ) // Neue Datei
   oBtn:activate := {||Msgbox("new","Codeblock")}

   ::oToolbar:addItem("open"    ,STD_IMAGE_FILEOPEN ,,,,,,,, {||Msgbox("open","Codeblock")} )
   ::oToolbar:addItem("save"    ,STD_IMAGE_FILESAVE  )
   ::oToolbar:addItem(" ",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

   ::oToolbar:addItem("copy"    ,STD_IMAGE_COPY      ) // Kopieren
   ::oToolbar:addItem("paste"   ,STD_IMAGE_PASTE     ) // Einfgen
   ::oToolbar:addItem("cut"     ,STD_IMAGE_CUT       ) // Ausschneiden
   ::oToolbar:addItem(" ",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

   ::oToolbar:addItem("del"     ,STD_IMAGE_DELETE    ) // Lschen
   ::oToolbar:addItem(" ",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

   ::oToolbar:addItem("print"   ,STD_IMAGE_PRINT     ) // Drucken
   ::oToolbar:addItem("view"    ,STD_IMAGE_PRINTPRE  ) // Druckvorschau
   ::oToolbar:addItem(" ",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

   ::oToolbar:addItem("find"    ,STD_IMAGE_FIND      ) // Suchen
   ::oToolbar:addItem("replace" ,STD_IMAGE_REPLACE   ) // Ersetzen
   ::oToolbar:addItem(" ",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

   ::oToolbar:addItem("redo"    ,STD_IMAGE_REDO      ) // Wiederholen
   ::oToolbar:addItem("undo"    ,STD_IMAGE_UNDO      ) // Rckgngig machen
   ::oToolbar:addItem(" ",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

   oBtn := ::oToolbar:addItem("proprty" ,STD_IMAGE_PROPERTIES,,,,XBPTOOLBAR_BUTTON_DROPDOWN,, "ICO") // Einstellungen
   oBtn:tooltipText:= "Hello world Text long"

   oBtn:addItem( "Eintrag #1", "ITEM1" )
   oBtn:addItem( "Eintrag #2", "ITEM2" )
   oBtn:addItem( "Eintrag #3", "ITEM3" )

   ::oToolbar:addItem(" ",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

   ::oToolbar:addItem("?"       ,STD_IMAGE_HELP      ) // Hilfe
   ::oToolbar:addItem(" ",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

*   IF ::oToolbar:isDerivedFrom("DXE_ToolBar")
*      //
*      // Workaround :
*      // if Text on Bottom is crop
*      //
*      aBtnSize := ::oToolbar:GetButtonSize()
*      aBtnSize[2] += 1
*      ::oToolbar:SetButtonSize(aBtnSize)
*   ENDIF

   ::oToolbar:show()

RETURN

PROCEDURE HandleItemClick( oMenu )
   DO CASE
      CASE oMenu:Key == "ITEM1"
         MsgBox( "Drop-down-Meneintrag #1 ausgewhlt!" )
      CASE oMenu:Key == "ITEM2"
         MsgBox( "Es wurde Eintrag #2 angeklickt." )
      CASE oMenu:Key == "ITEM3"
         MsgBox( "Dieses Mal war es Meneintrag #3." )
   ENDCASE
RETURN

PROCEDURE HandleItemRClick( oMenu )

   IF VALTYPE(oMenu:activate) = "B"
      EVAL(oMenu:activate)
   ELSE
      Msgbox( "caption : "+VAR2CHAR(oMenu:caption )+CRLF+;
              "enabled : "+VAR2CHAR(oMenu:enabled )+CRLF+;
              "index   : "+VAR2CHAR(oMenu:index   )+CRLF+;
              "key     : "+VAR2CHAR(oMenu:key     )+CRLF+;
              "visible : "+VAR2CHAR(oMenu:visible )+CRLF+;
              "activate: "+VAR2CHAR(oMenu:activate)+CRLF+;
              "Type    : "+VAR2CHAR(oMenu         )+CRLF+;
              "Size    : "+VAR2CHAR(oMenu:Currentsize()) )
  ENDIF
RETURN

//EOF
/////