
#INCLUDE "xbp.ch"
#INCLUDE "Appevent.ch"
#INCLUDE "common.ch"
#INCLUDE "inkey.ch"

#DEFINE VK_F4              0x73
#DEFINE KEYEVENTF_KEYUP    0x0002
#DEFINE CRLF               CHR(13)+CHR(10)

#IFDEF UseDXE
#INCLUDE "DLL.ch"
   DLLFUNCTION GetModuleHandleA( cModule ) USING STDCALL FROM KERNEL32.DLL
#ENDIF

PROCEDURE appsys ; return
// ---------------------------------------------------------------------------

PROCEDURE Main()
LOCAL nEvent, oXbp, mp1, mp2
LOCAL oDlg
LOCAL aSize

   SET DATE GERMAN
   SET CENTURY ON
   SET ALTER TO LOGFILE1.TXT

   //
   oDlg := TbDialog():New(AppDesktop(),,{0,0}, {700,480},,.T.)

   oDlg:taskList := .T.
   oDlg:title    := "native Toolbar"
   oDlg:icon     := 1
   oDlg:close    := {|p1,p2,oo| PostAppEvent(xbeP_Quit,,,oo) }
   oDlg:Create()
   oDlg:drawingArea:resize := {| aOldSize, aNewSize, oSelf | MyResize(aOldSize,aNewSize,oSelf,oDlg)  }

   oDlg:drawingArea:ClipChildren := .T.
   CenterControl(oDlg)


   // when using ::oToolbar:showToolTips := .T.
   oDlg:CreateToolbar(32,"DXE_TBAR.EXE")

   // Text under Image
   // oDlg:CreateToolbar(44,"DXE_TBAR.EXE")

   oDlg:Show()
   SetAppFocus( oDlg )

   aSize := oDlg:drawingArea:CurrentSize()
   aSize[1] += 1
   aSize[2] += 1
   PostAppEvent(xbeP_Resize,{1,1},aSize, oDlg:drawingArea )

   nEvent := xbe_None
   WHILE nEvent != xbeP_Close
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent ( nEvent, mp1, mp2 )
      IF nEvent == xbeP_Quit
         QUIT   // AppQuit()
      ENDIF
   ENDDO

   oDlg:destroy()
   SET ALTER TO

RETURN

PROCEDURE MyResize(aOldSize,aNewSize,oSelf,oDlg)
LOCAL nHeight := 44
LOCAL aChild := {}
LOCAL i,iMax
LOCAL oBtn
LOCAL aPos        := oDlg:CurrentPos()
LOCAL aMainPos    := {0,0}

   IF aOldSize[1] == 0 .AND. aOldSize[2] == 0               // was minimize
      aOldSize := aNewSize                                  // New Size

   ELSEIF aNewSize[1] == 0 .OR. aNewSize[2] == 0            // is now minimized
      RETURN

   ELSEIF aNewSize[1] == aOldSize[1] .AND. aNewSize[2] == aOldSize[2]
      RETURN
   ENDIF                                                    // same Size

   oSelf:lockUpdate(.T.)

   IF oDlg:oToolbar:isDerivedFrom("DXE_ToolBar")
      nHeight := oDlg:oToolbar:buttonHeight
   ENDIF

   oDlg:oToolbar:setPos({0,aNewSize[2]-nHeight})
   oDlg:oToolbar:setSize({aNewSize[1],nHeight})

   oSelf:lockUpdate(.F.)
   oSelf:invalidateRect()

RETURN


CLASS TbForm FROM XbpDialog
   EXPORTED:

      VAR oToolbar
      VAR oFontName
      VAR oFontSize

      METHOD init
      METHOD create
ENDCLASS

METHOD TbForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )

   DEFAULT oParent  TO AppDesktop(), ;
           aPos     TO {2,-3}, ;
           lVisible TO .F.

   DEFAULT aPP TO {}
   AAdd ( aPP, { XBP_PP_COMPOUNDNAME, "8.Arial" } )

   IF Empty(aSize) == .T.
      IF IsMemberVar(self,"ClientSize") == .T.
         aSize := {0,0}
      ELSE
         aSize := {340,276}
      ENDIF
   ENDIF

   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   IF aSize[1] == 0 .AND. aSize[2] == 0
      ::XbpDialog:ClientSize := {332,250}
   ENDIF

RETURN self

METHOD TbForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

CLASS TbDialog FROM TbForm
   EXPORTED:
      METHOD init
      METHOD create

      METHOD CreateToolbar(cDLL)
ENDCLASS

METHOD TbDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::TbForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

METHOD TbDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::TbForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

METHOD TbDialog:CreateToolbar(nHeight,cDLL)
LOCAL aSize   := ::DrawingArea:CurrentSize()
LOCAL hModule
LOCAL oButton
LOCAL aFonts
LOCAL aFontSizes
LOCAL aFontNames
LOCAL lExact
LOCAL nCont,nLen
LOCAL aPos    := {0,0}
LOCAL aBtnSize

DEFAULT nHeight TO 40

   IF VALTYPE(nHeight) = "N"
      aPos[2] := aSize[2] -nHeight
      aSize[2] := nHeight
   ELSE
      Msgbox("Error Parameter"+VAR2CHAR(nHeight))
      RETURN self
   ENDIF

   IF ValType(cDLL) == "C"
      hModule := GetModuleHandleA( cDLL )
   ELSE
      hModule := GetModuleHandleA( 0 )
   ENDIF

   ::oToolbar := DXE_Toolbar():New(::DrawingArea,,aPos,aSize,,.F.)

   ::oToolbar:Style := XBPTOOLBAR_STYLE_FLAT
*  ::oToolbar:BorderStyle  := XBPFRAME_RECT

   //
   // Property to set before Create !!!
   //
   ::oToolbar:borderStyle  := XBPFRAME_NONE      // all other give WS_BORDER
   ::oToolbar:textAlign    := XBPALIGN_BOTTOM    // or XBPALIGN_RIGHT
   ::oToolbar:appearance   := XBP_APPEARANCE_3D  // or XBP_APPEARANCE_FLAT
   ::oToolbar:wrappable    := .F.
   ::oToolbar:showToolTips := .T.
   ::oToolbar:lNORESIZE    := .T.                // is CCS_NORESIZE

   ::oToolbar:create()


   //
   // not in Xbase++
   //
   IF ::oToolbar:isDerivedFrom( "DXE_Toolbar")
      ::oToolbar:buttonRClick    := {|oButton| HandleItemRClick(oButton)}
   ENDIF

   ::oToolbar:buttonClick := {|oButton| HandlebuttonClick(oButton) }

   ::oToolbar:ButtonMenuClick := {|oButton| HandleItemClick(oButton)}

   //
   // load System Icon.
   // must be first
   //
   ::oToolbar:loadImageSet( XBPTOOLBAR_STDIMAGES_SMALL )
*  ::oToolbar:loadImageSet( XBPTOOLBAR_STDIMAGES_LARGE )

   //
   // Syntax
   //
   // Additem(cCaption, xImage, xDisabledImage, xHotImage, cDLL, nStyle, cKey, cImageType, nWidth ,bAction)
   //
   // new Parameter not in Xbase++
   //
   // cImageType : "ICO" or "BMP" as Resource
   // nWidth     : fixed Wide if need e.g. Placeholder or DropDownMenu
   // bAction    : Activate Codeblock Slot

   ::oToolbar:addItem("new"     ,STD_IMAGE_FILENEW   ,,,,,,,,{|| Msgbox("new" ,"Codeblock")} )
   ::oToolbar:addItem("open"    ,STD_IMAGE_FILEOPEN  ,,,,,,,,{|| Msgbox("open","Codeblock")} )

   oButton := ::oToolbar:addItem("save"    ,STD_IMAGE_FILESAVE )
   oButton:activate := {|| Msgbox("save","Codeblock")}

   ::oToolbar:addItem("",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

*  ::oFontName          := XbpComboBox():new()
   ::oFontName          := XbpComboBox():new(::oToolbar, , {  8,-150}, {220,172}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } ,.T.)
   ::oFontName:tabstop  := .T.
   ::oFontName:border   := .F.

*  oButton := ::oToolbar:addItem("",,,,, XBPTOOLBAR_BUTTON_PLACEHOLDER,"FONTNAME",,220 )
   oButton              := ::oToolbar:addItem()
   oButton:Style        := XBPTOOLBAR_BUTTON_PLACEHOLDER
   oButton:Width        := 220
   oButton:key          := "FONTNAME"
   //
   // this is different in DXE
   // you must set ::oToolbar as Parent at new() NOT at create()
   //
*  ::oFontName:create(::oToolbar, , {  8,-150}, {220,172}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } ,.T.)
   ::oFontName:create()
**1**   ::oFontName:setPos( {oButton:Left, oButton:Top } )
   ::oFontName:ItemSelected := { |u1, u2, oSelf| Msgbox(oSelf:GetItem( oSelf:getdata()[1] ))}
   ::oFontName:Cargo := "oFontName"

   ::oToolbar:addItem("",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

*  ::oFontSize          := XbpComboBox():new()
   ::oFontSize          := XbpComboBox():new(::oToolbar, , {244,-150}, { 56,172}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } ,.T.)
   ::oFontSize:tabstop  := .T.
   ::oFontSize:border   := .F.

*  oButton := ::oToolbar:addItem("",,,,, XBPTOOLBAR_BUTTON_PLACEHOLDER,"FONTSIZE",,56 )
   oButton              := ::oToolbar:addItem()
   oButton:Style        := XBPTOOLBAR_BUTTON_PLACEHOLDER
   oButton:key          := "FONTSIZE"
   oButton:width        := 56

*  ::oFontSize:create(::oToolbar, , {244,-150}, { 56,172}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD } } ,.T.)
   ::oFontSize:create()
**1**   ::oFontSize:setPos( {oButton:Left, oButton:Top } )
   ::oFontSize:ItemSelected := { |u1, u2, oSelf| Msgbox(oSelf:GetItem( oSelf:getdata()[1] ))}
   ::oFontSize:Cargo := "oFontSize"

   ::oToolbar:addItem("",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

*  oButton := ::oToolbar:addItem("Copy",STD_IMAGE_COPY)
*  oButton := ::oToolbar:addItem("Copy")
   oButton := ::oToolbar:addItem()
   oButton:image        := STD_IMAGE_COPY
*  oButton:key          := ""
   oButton:tooltipText  := "Copy_TT"

*  oButton := ::oToolbar:addItem("Paste",STD_IMAGE_PASTE)
*  oButton := ::oToolbar:addItem("Paste")
   oButton := ::oToolbar:addItem()
   oButton:image        := STD_IMAGE_PASTE
*  oButton:key          := ""
   oButton:tooltipText  := "Paste_TT"

*  oButton := ::oToolbar:addItem("Cut",STD_IMAGE_CUT)
*  oButton := ::oToolbar:addItem("Cut")
   oButton := ::oToolbar:addItem()
   oButton:image        := STD_IMAGE_CUT
   oButton:key          := "Cut_Key"
   oButton:tooltipText  := "Cut_TT"

   ::oToolbar:addItem("",,,,, XBPTOOLBAR_BUTTON_SEPARATOR )

   oButton := ::oToolbar:Additem("Del" , 103 ,,,,                           ,, "ICO" )
*  oButton:Caption      := "Del"
*  oButton:image        := 103
*  oButton:cImageType   := "ICO"
   oButton:tooltipText  := "hello"

   oButton := ::oToolbar:addItem("Edit", 104 ,,,,                           ,, "ICO" )
   oButton:tooltipText  := "world"

   oButton := ::oToolbar:addItem("Undo", 105 ,,,, XBPTOOLBAR_BUTTON_DROPDOWN,, "ICO" )
   oButton:tooltipText  := "Hello world Text long"

   //
   // use activate Codeblock as 3th Parameter
   //
   oButton:addItem( "Eintrag #1", "ITEM1",{|| Msgbox("Codeblock Item1") } )
   //
   // else use 2nd Parameter "Key"
   //
   oButton:addItem( "Eintrag #2", "ITEM2",{|| Msgbox("Codeblock Item2") } )
   oButton:addItem( "Eintrag #3", "ITEM3" )

   aFonts := XbpFont():new( ::DrawingArea:lockPS() ):list()
      ::DrawingArea:unlockPS()
      aFontNames:= {}
      AEval( aFonts, {|o| IF( AScan( aFontNames, o:familyName ) == 0, ;
                              AAdd( aFontNames, o:familyName ), nil ) } )

      lExact:= Set( _SET_EXACT, .T. )
      aFontNames:= ASort( aFontNames )
      Set( _SET_EXACT, lExact )

      nLen:= Len( aFontNames )
      FOR nCont:= 1 TO nLen
         ::oFontName:addItem( aFontNames[ nCont ] )
      NEXT

   aFontSizes:= { '8', '10', '12', '14', '18', '24', '36' }

      nLen:= Len( aFontSizes )
      FOR nCont:= 1 TO nLen
         ::oFontSize:addItem( aFontSizes[ nCont ] )
      NEXT

   ::oFontName:setdata("Arial")
   ::oFontSize:setdata("10")

   IF ::oToolbar:isDerivedFrom("DXE_ToolBar")
      //
      // Workaround
      // if Text on Bottom is crop
      //
      // aBtnSize := ::oToolbar:GetButtonSize()
      // aBtnSize[2] += 1
      // ::oToolbar:SetButtonSize(aBtnSize)
   ENDIF

   ::oToolbar:show()

RETURN

PROCEDURE HandlebuttonClick(oButton)
LOCAL oChild

   IF VALTYPE(oButton:activate)="B"
      EVAL(oButton:activate)

   ELSEIF !EMPTY( oButton:Childlist() )

      oChild := oButton:Childlist()[1]
      IF oChild:isDerivedFrom("XbpComboBox")
         SetAppFocus(oChild)
         keybd_event( VK_F4, 0, 0, 0 )
         keybd_event( VK_F4, 0, KEYEVENTF_KEYUP, 0 )
      ENDIF

   ELSE
      IF EMPTY(oButton:index)
      ELSE
         MsgBox("Knopf [" + ;
                 LTRIM(STR(oButton:index))+" "+ ;
                  Var2Char(oButton:caption)+ ;
                 "] angeklickt!")
      ENDIF
   ENDIF
RETURN

PROCEDURE HandleItemClick( oButton )
   DO CASE
      CASE oButton:Key == "ITEM1"
         MsgBox( "Drop-down-Meneintrag #1 ausgewhlt!" )
      CASE oButton:Key == "ITEM2"
         MsgBox( "Es wurde Eintrag #2 angeklickt." )
      CASE oButton:Key == "ITEM3"
         MsgBox( "Dieses Mal war es Meneintrag #3." )
   ENDCASE
RETURN


PROCEDURE HandleItemRClick( oButton )
LOCAL aRc := {0,0,0,0}

*   IF VALTYPE(oButton:activate) = "B"
*      EVAL(oButton:activate)
*      RETURN
*   ENDIF

   IF oButton:isDerivedFrom( "DXE_ToolbarButton")
      aRc[1] := oButton:left
      aRc[2] := oButton:top
      aRc[3] := oButton:right
      aRc[4] := oButton:bottom
   ENDIF

   Msgbox( "caption : "+VAR2CHAR(oButton:caption )+CRLF+;
           "enabled : "+VAR2CHAR(oButton:enabled )+CRLF+;
           "index   : "+VAR2CHAR(oButton:index   )+CRLF+;
           "key     : "+VAR2CHAR(oButton:key     )+CRLF+;
           "visible : "+VAR2CHAR(oButton:visible )+CRLF+;
           "activate: "+VAR2CHAR(oButton:activate)+CRLF+;
           "Type    : "+VAR2CHAR(oButton         )+CRLF+;
           "Child   : "+VAR2CHAR(oButton:Childlist() )+CRLF+;
           "Size    : "+VAR2CHAR(aRc) )
RETURN

FUNCTION keybd_event( nVk, nScan, nFlags, nExtraInfo )

STATIC keybd_event
   IF keybd_event = NIL
      keybd_event := DllPrepareCall( "user32.dll", DLL_STDCALL, "keybd_event" )
   ENDIF
RETURN DllExecuteCall( keybd_event, nVk, nScan, nFlags, nExtraInfo )

//EOF
/////